/* original parser id follows */
/* yysccsid[] = "@(#)yaccpar	1.9 (Berkeley) 02/21/93" */
/* (use YYMAJOR/YYMINOR for ifdefs dependent on parser version) */

#define YYBYACC 1
#define YYMAJOR 1
#define YYMINOR 9
#define YYPATCH 20160324

#define YYEMPTY        (-1)
#define yyclearin      (yychar = YYEMPTY)
#define yyerrok        (yyerrflag = 0)
#define YYRECOVERING() (yyerrflag != 0)
#define YYENOMEM       (-2)
#define YYEOF          0
#define YYPREFIX "yy"

#define YYPURE 0

#line 2 "attack_parser.y"

/*
 * Copyright (c) 2007,2008,2009,2010 Mij <mij@sshguard.net>
 *
 * Permission to use, copy, modify, and distribute this software for any
 * purpose with or without fee is hereby granted, provided that the above
 * copyright notice and this permission notice appear in all copies.
 *
 * THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES
 * WITH REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF
 * MERCHANTABILITY AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR
 * ANY SPECIAL, DIRECT, INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES
 * WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN
 * ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF
 * OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
 */

/*
 * SSHGuard. See http://www.sshguard.net
 */

#include <string.h>

#include "parser.h"

#define DEFAULT_ATTACKS_DANGEROUSNESS           10

 /* stuff exported by the scanner */
extern void scanner_init();
extern void scanner_fin();
extern int yylex();

static void yyerror(attack_t *, const char *);

#line 43 "attack_parser.y"
#ifdef YYSTYPE
#undef  YYSTYPE_IS_DECLARED
#define YYSTYPE_IS_DECLARED 1
#endif
#ifndef YYSTYPE_IS_DECLARED
#define YYSTYPE_IS_DECLARED 1
typedef union {
    char *str;
    int num;
} YYSTYPE;
#endif /* !YYSTYPE_IS_DECLARED */
#line 68 "attack_parser.c"

/* compatibility with bison */
#ifdef YYPARSE_PARAM
/* compatibility with FreeBSD */
# ifdef YYPARSE_PARAM_TYPE
#  define YYPARSE_DECL() yyparse(YYPARSE_PARAM_TYPE YYPARSE_PARAM)
# else
#  define YYPARSE_DECL() yyparse(void *YYPARSE_PARAM)
# endif
#else
# define YYPARSE_DECL() yyparse(attack_t *attack)
#endif

/* Parameters sent to lex. */
#ifdef YYLEX_PARAM
# define YYLEX_DECL() yylex(void *YYLEX_PARAM)
# define YYLEX yylex(YYLEX_PARAM)
#else
# define YYLEX_DECL() yylex(void)
# define YYLEX yylex()
#endif

/* Parameters sent to yyerror. */
#ifndef YYERROR_DECL
#define YYERROR_DECL() yyerror(attack_t *attack, const char *s)
#endif
#ifndef YYERROR_CALL
#define YYERROR_CALL(msg) yyerror(attack, msg)
#endif

extern int YYPARSE_DECL();

#define IPv4 257
#define IPv6 258
#define HOSTADDR 259
#define WORD 260
#define INTEGER 261
#define SYSLOG_BANNER_PID 262
#define SOCKLOG_BANNER_PID 263
#define SYSLOG_BANNER 264
#define TIMESTAMP_SYSLOG 265
#define TIMESTAMP_ISO8601 266
#define TIMESTAMP_TAI64 267
#define AT_TIMESTAMP_TAI64 268
#define METALOG_BANNER 269
#define SOCKLOG_BANNER 270
#define SSH_INVALUSERPREF 271
#define SSH_NOTALLOWEDPREF 272
#define SSH_NOTALLOWEDSUFF 273
#define SSH_LOGINERR_PREF 274
#define SSH_LOGINERR_SUFF 275
#define SSH_LOGINERR_PAM 276
#define SSH_VIA 277
#define SSH_NOIDENTIFSTR 278
#define SSH_BADPROTOCOLIDENTIF 279
#define SSH_BADPROTOCOLIDENTIF_SUFF 280
#define SSH_BADKEX_PREF 281
#define SSH_BADKEX_SUFF 282
#define SSH_DISCONNECT_PREF 283
#define SSH_PREAUTH_SUFF 284
#define DOVECOT_IMAP_LOGINERR_PREF 285
#define DOVECOT_IMAP_LOGINERR_SUFF 286
#define UWIMAP_LOGINERR 287
#define CYRUSIMAP_SASL_LOGINERR_PREF 288
#define CYRUSIMAP_SASL_LOGINERR_SUFF 289
#define CUCIPOP_AUTHFAIL 290
#define EXIM_ESMTP_AUTHFAIL_PREF 291
#define EXIM_ESMTP_AUTHFAIL_SUFF 292
#define SENDMAIL_RELAYDENIED_PREF 293
#define SENDMAIL_RELAYDENIED_SUFF 294
#define SENDMAIL_AUTHFAILURE_PREF 295
#define SENDMAIL_AUTHFAILURE_SUFF 296
#define POSTFIX_NO_AUTH_PREF 297
#define POSTFIX_SASL_LOGINERR_PREF 298
#define POSTFIX_SASL_LOGINERR_SUFF 299
#define FREEBSDFTPD_LOGINERR_PREF 300
#define FREEBSDFTPD_LOGINERR_SUFF 301
#define PROFTPD_LOGINERR_PREF 302
#define PROFTPD_LOGINERR_SUFF 303
#define PUREFTPD_LOGINERR_PREF 304
#define PUREFTPD_LOGINERR_SUFF 305
#define VSFTPD_LOGINERR_PREF 306
#define VSFTPD_LOGINERR_SUFF 307
#define YYERRCODE 256
typedef int YYINT;
static const YYINT yylhs[] = {                           -1,
    0,    0,    0,    0,    0,    1,    1,    2,    3,    4,
    4,    5,    6,    6,    6,    6,    6,    6,    6,    6,
    6,    6,    6,    6,   19,   19,   19,    7,    7,    7,
    7,    7,   20,   20,   21,   21,   21,   22,   22,   23,
   24,    8,    9,   10,   11,   12,   13,   13,   14,   14,
   15,   16,   17,   18,
};
static const YYINT yylen[] = {                            2,
    1,    1,    1,    1,    1,    2,    2,    2,    2,    2,
    2,    1,    1,    1,    1,    1,    1,    1,    1,    1,
    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
    1,    1,    2,    3,    3,    2,    3,    2,    3,    3,
    3,    3,    4,    3,    2,    3,    3,    3,    3,    3,
    3,    3,    3,    3,
};
static const YYINT yydefred[] = {                         0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    1,    2,
    3,    4,    5,   12,   13,   14,   15,   16,   17,   18,
   19,   20,   21,   22,   23,   24,   28,   29,   30,   31,
   32,    6,   10,    7,    8,    9,   11,   25,   26,   27,
   33,    0,    0,    0,   38,    0,    0,    0,    0,    0,
    0,   45,    0,    0,    0,    0,    0,    0,    0,    0,
    0,   34,   35,   37,   40,   41,   39,   42,    0,   44,
   46,   47,   48,   50,   49,   51,   52,   53,   54,   43,
};
static const YYINT yydgoto[] = {                         28,
   29,   30,   31,   32,   33,   34,   35,   36,   37,   38,
   39,   40,   41,   42,   43,   44,   45,   46,   61,   47,
   48,   49,   50,   51,
};
static const YYINT yysindex[] = {                      -241,
 -205, -205, -205, -205, -205, -205, -233, -233, -233, -233,
 -233, -233, -233, -233, -233,  -83, -233, -233, -233, -233,
 -233, -233, -233, -233, -233, -233, -233,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0, -253, -243, -238,    0, -246, -239, -248, -245, -233,
 -244,    0, -237, -236, -232,  -45, -231, -250, -228, -252,
 -247,    0,    0,    0,    0,    0,    0,    0,  -23,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
};
static const YYINT yyrindex[] = {                         0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,   72,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
};
static const YYINT yygindex[] = {                         0,
    0,    0,    0,    0,  101,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,   -8,    0,
    0,    0,    0,    0,
};
#define YYTABLESIZE 107
static const YYINT yytable[] = {                         62,
   63,   64,   65,   66,   67,   68,   69,   70,   71,   72,
   73,   74,   75,   76,   77,   78,   79,   80,   81,   82,
    1,    2,    3,   58,   59,   60,    4,    5,    6,    7,
    8,   83,    9,   85,   10,   87,   11,   12,   84,   13,
   88,   14,   86,   15,   90,   16,   17,   94,   18,   19,
   96,   20,   98,   21,   91,   22,   23,   92,   24,   99,
   25,   89,   26,   93,   27,    7,    8,   95,    9,  100,
   10,   36,   11,   12,   97,   13,    0,   14,    0,   15,
    0,   16,   17,    0,   18,   19,    0,   20,    0,   21,
    0,   22,   23,    0,   24,    0,   25,    0,   26,    0,
   27,   52,   53,   54,   55,   56,   57,
};
static const YYINT yycheck[] = {                          8,
    9,   10,   11,   12,   13,   14,   15,   91,   17,   18,
   19,   20,   21,   22,   23,   24,   25,   26,   27,  273,
  262,  263,  264,  257,  258,  259,  268,  269,  270,  271,
  272,  275,  274,  280,  276,  284,  278,  279,  277,  281,
  286,  283,  282,  285,  289,  287,  288,   93,  290,  291,
  301,  293,  305,  295,  292,  297,  298,  294,  300,  307,
  302,   70,  304,  296,  306,  271,  272,  299,  274,   93,
  276,    0,  278,  279,  303,  281,   -1,  283,   -1,  285,
   -1,  287,  288,   -1,  290,  291,   -1,  293,   -1,  295,
   -1,  297,  298,   -1,  300,   -1,  302,   -1,  304,   -1,
  306,    1,    2,    3,    4,    5,    6,
};
#define YYFINAL 28
#ifndef YYDEBUG
#define YYDEBUG 0
#endif
#define YYMAXTOKEN 307
#define YYUNDFTOKEN 334
#define YYTRANSLATE(a) ((a) > YYMAXTOKEN ? YYUNDFTOKEN : (a))
#if YYDEBUG
static const char *const yyname[] = {

"end-of-file",0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,"'['",0,"']'",0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,"IPv4","IPv6","HOSTADDR",
"WORD","INTEGER","SYSLOG_BANNER_PID","SOCKLOG_BANNER_PID","SYSLOG_BANNER",
"TIMESTAMP_SYSLOG","TIMESTAMP_ISO8601","TIMESTAMP_TAI64","AT_TIMESTAMP_TAI64",
"METALOG_BANNER","SOCKLOG_BANNER","SSH_INVALUSERPREF","SSH_NOTALLOWEDPREF",
"SSH_NOTALLOWEDSUFF","SSH_LOGINERR_PREF","SSH_LOGINERR_SUFF","SSH_LOGINERR_PAM",
"SSH_VIA","SSH_NOIDENTIFSTR","SSH_BADPROTOCOLIDENTIF",
"SSH_BADPROTOCOLIDENTIF_SUFF","SSH_BADKEX_PREF","SSH_BADKEX_SUFF",
"SSH_DISCONNECT_PREF","SSH_PREAUTH_SUFF","DOVECOT_IMAP_LOGINERR_PREF",
"DOVECOT_IMAP_LOGINERR_SUFF","UWIMAP_LOGINERR","CYRUSIMAP_SASL_LOGINERR_PREF",
"CYRUSIMAP_SASL_LOGINERR_SUFF","CUCIPOP_AUTHFAIL","EXIM_ESMTP_AUTHFAIL_PREF",
"EXIM_ESMTP_AUTHFAIL_SUFF","SENDMAIL_RELAYDENIED_PREF",
"SENDMAIL_RELAYDENIED_SUFF","SENDMAIL_AUTHFAILURE_PREF",
"SENDMAIL_AUTHFAILURE_SUFF","POSTFIX_NO_AUTH_PREF","POSTFIX_SASL_LOGINERR_PREF",
"POSTFIX_SASL_LOGINERR_SUFF","FREEBSDFTPD_LOGINERR_PREF",
"FREEBSDFTPD_LOGINERR_SUFF","PROFTPD_LOGINERR_PREF","PROFTPD_LOGINERR_SUFF",
"PUREFTPD_LOGINERR_PREF","PUREFTPD_LOGINERR_SUFF","VSFTPD_LOGINERR_PREF",
"VSFTPD_LOGINERR_SUFF",0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
"illegal-symbol",
};
static const char *const yyrule[] = {
"$accept : text",
"text : syslogent",
"text : multilogent",
"text : metalogent",
"text : socklogent",
"text : logmsg",
"syslogent : SYSLOG_BANNER_PID logmsg",
"syslogent : SYSLOG_BANNER logmsg",
"multilogent : AT_TIMESTAMP_TAI64 logmsg",
"metalogent : METALOG_BANNER logmsg",
"socklogent : SOCKLOG_BANNER_PID logmsg",
"socklogent : SOCKLOG_BANNER logmsg",
"logmsg : msg_single",
"msg_single : sshmsg",
"msg_single : dovecotmsg",
"msg_single : uwimapmsg",
"msg_single : cyrusimapmsg",
"msg_single : cucipopmsg",
"msg_single : eximmsg",
"msg_single : sendmailmsg",
"msg_single : postfixmsg",
"msg_single : freebsdftpdmsg",
"msg_single : proftpdmsg",
"msg_single : pureftpdmsg",
"msg_single : vsftpdmsg",
"addr : IPv4",
"addr : IPv6",
"addr : HOSTADDR",
"sshmsg : ssh_illegaluser",
"sshmsg : ssh_authfail",
"sshmsg : ssh_noidentifstring",
"sshmsg : ssh_badprotocol",
"sshmsg : ssh_badkex",
"ssh_illegaluser : SSH_INVALUSERPREF addr",
"ssh_illegaluser : SSH_NOTALLOWEDPREF addr SSH_NOTALLOWEDSUFF",
"ssh_authfail : SSH_LOGINERR_PREF addr SSH_LOGINERR_SUFF",
"ssh_authfail : SSH_LOGINERR_PAM addr",
"ssh_authfail : SSH_LOGINERR_PAM addr SSH_VIA",
"ssh_noidentifstring : SSH_NOIDENTIFSTR addr",
"ssh_noidentifstring : SSH_DISCONNECT_PREF addr SSH_PREAUTH_SUFF",
"ssh_badprotocol : SSH_BADPROTOCOLIDENTIF addr SSH_BADPROTOCOLIDENTIF_SUFF",
"ssh_badkex : SSH_BADKEX_PREF addr SSH_BADKEX_SUFF",
"dovecotmsg : DOVECOT_IMAP_LOGINERR_PREF addr DOVECOT_IMAP_LOGINERR_SUFF",
"uwimapmsg : UWIMAP_LOGINERR '[' addr ']'",
"cyrusimapmsg : CYRUSIMAP_SASL_LOGINERR_PREF addr CYRUSIMAP_SASL_LOGINERR_SUFF",
"cucipopmsg : CUCIPOP_AUTHFAIL addr",
"eximmsg : EXIM_ESMTP_AUTHFAIL_PREF addr EXIM_ESMTP_AUTHFAIL_SUFF",
"sendmailmsg : SENDMAIL_RELAYDENIED_PREF addr SENDMAIL_RELAYDENIED_SUFF",
"sendmailmsg : SENDMAIL_AUTHFAILURE_PREF addr SENDMAIL_AUTHFAILURE_SUFF",
"postfixmsg : POSTFIX_SASL_LOGINERR_PREF addr POSTFIX_SASL_LOGINERR_SUFF",
"postfixmsg : POSTFIX_NO_AUTH_PREF addr ']'",
"freebsdftpdmsg : FREEBSDFTPD_LOGINERR_PREF addr FREEBSDFTPD_LOGINERR_SUFF",
"proftpdmsg : PROFTPD_LOGINERR_PREF addr PROFTPD_LOGINERR_SUFF",
"pureftpdmsg : PUREFTPD_LOGINERR_PREF addr PUREFTPD_LOGINERR_SUFF",
"vsftpdmsg : VSFTPD_LOGINERR_PREF addr VSFTPD_LOGINERR_SUFF",

};
#endif

int      yydebug;
int      yynerrs;

int      yyerrflag;
int      yychar;
YYSTYPE  yyval;
YYSTYPE  yylval;

/* define the initial stack-sizes */
#ifdef YYSTACKSIZE
#undef YYMAXDEPTH
#define YYMAXDEPTH  YYSTACKSIZE
#else
#ifdef YYMAXDEPTH
#define YYSTACKSIZE YYMAXDEPTH
#else
#define YYSTACKSIZE 10000
#define YYMAXDEPTH  10000
#endif
#endif

#define YYINITSTACKSIZE 200

typedef struct {
    unsigned stacksize;
    YYINT    *s_base;
    YYINT    *s_mark;
    YYINT    *s_last;
    YYSTYPE  *l_base;
    YYSTYPE  *l_mark;
} YYSTACKDATA;
/* variables for the parser stack */
static YYSTACKDATA yystack;
#line 257 "attack_parser.y"

static void yyerror(__attribute__((unused)) attack_t *a,
    __attribute__((unused)) const char *s) { /* do nothing */ }

int parse_line(char *str, attack_t *attack) {
    attack->dangerousness = DEFAULT_ATTACKS_DANGEROUSNESS;

    scanner_init(str);
    int ret = yyparse(attack);
    scanner_fin();

    return ret;
}
#line 385 "attack_parser.c"

#if YYDEBUG
#include <stdio.h>		/* needed for printf */
#endif

#include <stdlib.h>	/* needed for malloc, etc */
#include <string.h>	/* needed for memset */

/* allocate initial stack or double stack size, up to YYMAXDEPTH */
static int yygrowstack(YYSTACKDATA *data)
{
    int i;
    unsigned newsize;
    YYINT *newss;
    YYSTYPE *newvs;

    if ((newsize = data->stacksize) == 0)
        newsize = YYINITSTACKSIZE;
    else if (newsize >= YYMAXDEPTH)
        return YYENOMEM;
    else if ((newsize *= 2) > YYMAXDEPTH)
        newsize = YYMAXDEPTH;

    i = (int) (data->s_mark - data->s_base);
    newss = (YYINT *)realloc(data->s_base, newsize * sizeof(*newss));
    if (newss == 0)
        return YYENOMEM;

    data->s_base = newss;
    data->s_mark = newss + i;

    newvs = (YYSTYPE *)realloc(data->l_base, newsize * sizeof(*newvs));
    if (newvs == 0)
        return YYENOMEM;

    data->l_base = newvs;
    data->l_mark = newvs + i;

    data->stacksize = newsize;
    data->s_last = data->s_base + newsize - 1;
    return 0;
}

#if YYPURE || defined(YY_NO_LEAKS)
static void yyfreestack(YYSTACKDATA *data)
{
    free(data->s_base);
    free(data->l_base);
    memset(data, 0, sizeof(*data));
}
#else
#define yyfreestack(data) /* nothing */
#endif

#define YYABORT  goto yyabort
#define YYREJECT goto yyabort
#define YYACCEPT goto yyaccept
#define YYERROR  goto yyerrlab

int
YYPARSE_DECL()
{
    int yym, yyn, yystate;
#if YYDEBUG
    const char *yys;

    if ((yys = getenv("YYDEBUG")) != 0)
    {
        yyn = *yys;
        if (yyn >= '0' && yyn <= '9')
            yydebug = yyn - '0';
    }
#endif

    yynerrs = 0;
    yyerrflag = 0;
    yychar = YYEMPTY;
    yystate = 0;

#if YYPURE
    memset(&yystack, 0, sizeof(yystack));
#endif

    if (yystack.s_base == NULL && yygrowstack(&yystack) == YYENOMEM) goto yyoverflow;
    yystack.s_mark = yystack.s_base;
    yystack.l_mark = yystack.l_base;
    yystate = 0;
    *yystack.s_mark = 0;

yyloop:
    if ((yyn = yydefred[yystate]) != 0) goto yyreduce;
    if (yychar < 0)
    {
        if ((yychar = YYLEX) < 0) yychar = YYEOF;
#if YYDEBUG
        if (yydebug)
        {
            yys = yyname[YYTRANSLATE(yychar)];
            printf("%sdebug: state %d, reading %d (%s)\n",
                    YYPREFIX, yystate, yychar, yys);
        }
#endif
    }
    if ((yyn = yysindex[yystate]) && (yyn += yychar) >= 0 &&
            yyn <= YYTABLESIZE && yycheck[yyn] == yychar)
    {
#if YYDEBUG
        if (yydebug)
            printf("%sdebug: state %d, shifting to state %d\n",
                    YYPREFIX, yystate, yytable[yyn]);
#endif
        if (yystack.s_mark >= yystack.s_last && yygrowstack(&yystack) == YYENOMEM)
        {
            goto yyoverflow;
        }
        yystate = yytable[yyn];
        *++yystack.s_mark = yytable[yyn];
        *++yystack.l_mark = yylval;
        yychar = YYEMPTY;
        if (yyerrflag > 0)  --yyerrflag;
        goto yyloop;
    }
    if ((yyn = yyrindex[yystate]) && (yyn += yychar) >= 0 &&
            yyn <= YYTABLESIZE && yycheck[yyn] == yychar)
    {
        yyn = yytable[yyn];
        goto yyreduce;
    }
    if (yyerrflag) goto yyinrecovery;

    YYERROR_CALL("syntax error");

    goto yyerrlab;

yyerrlab:
    ++yynerrs;

yyinrecovery:
    if (yyerrflag < 3)
    {
        yyerrflag = 3;
        for (;;)
        {
            if ((yyn = yysindex[*yystack.s_mark]) && (yyn += YYERRCODE) >= 0 &&
                    yyn <= YYTABLESIZE && yycheck[yyn] == YYERRCODE)
            {
#if YYDEBUG
                if (yydebug)
                    printf("%sdebug: state %d, error recovery shifting\
 to state %d\n", YYPREFIX, *yystack.s_mark, yytable[yyn]);
#endif
                if (yystack.s_mark >= yystack.s_last && yygrowstack(&yystack) == YYENOMEM)
                {
                    goto yyoverflow;
                }
                yystate = yytable[yyn];
                *++yystack.s_mark = yytable[yyn];
                *++yystack.l_mark = yylval;
                goto yyloop;
            }
            else
            {
#if YYDEBUG
                if (yydebug)
                    printf("%sdebug: error recovery discarding state %d\n",
                            YYPREFIX, *yystack.s_mark);
#endif
                if (yystack.s_mark <= yystack.s_base) goto yyabort;
                --yystack.s_mark;
                --yystack.l_mark;
            }
        }
    }
    else
    {
        if (yychar == YYEOF) goto yyabort;
#if YYDEBUG
        if (yydebug)
        {
            yys = yyname[YYTRANSLATE(yychar)];
            printf("%sdebug: state %d, error recovery discards token %d (%s)\n",
                    YYPREFIX, yystate, yychar, yys);
        }
#endif
        yychar = YYEMPTY;
        goto yyloop;
    }

yyreduce:
#if YYDEBUG
    if (yydebug)
        printf("%sdebug: state %d, reducing by rule %d (%s)\n",
                YYPREFIX, yystate, yyn, yyrule[yyn]);
#endif
    yym = yylen[yyn];
    if (yym)
        yyval = yystack.l_mark[1-yym];
    else
        memset(&yyval, 0, sizeof yyval);
    switch (yyn)
    {
case 13:
#line 133 "attack_parser.y"
	{   attack->service = SERVICES_SSH; }
break;
case 14:
#line 134 "attack_parser.y"
	{   attack->service = SERVICES_DOVECOT; }
break;
case 15:
#line 135 "attack_parser.y"
	{   attack->service = SERVICES_UWIMAP; }
break;
case 16:
#line 136 "attack_parser.y"
	{   attack->service = SERVICES_CYRUSIMAP; }
break;
case 17:
#line 137 "attack_parser.y"
	{   attack->service = SERVICES_CUCIPOP; }
break;
case 18:
#line 138 "attack_parser.y"
	{   attack->service = SERVICES_EXIM; }
break;
case 19:
#line 139 "attack_parser.y"
	{   attack->service = SERVICES_SENDMAIL; }
break;
case 20:
#line 140 "attack_parser.y"
	{   attack->service = SERVICES_POSTFIX; }
break;
case 21:
#line 141 "attack_parser.y"
	{   attack->service = SERVICES_FREEBSDFTPD; }
break;
case 22:
#line 142 "attack_parser.y"
	{   attack->service = SERVICES_PROFTPD; }
break;
case 23:
#line 143 "attack_parser.y"
	{   attack->service = SERVICES_PUREFTPD; }
break;
case 24:
#line 144 "attack_parser.y"
	{   attack->service = SERVICES_VSFTPD; }
break;
case 25:
#line 149 "attack_parser.y"
	{
                        attack->address.kind = ADDRKIND_IPv4;
                        strcpy(attack->address.value, yystack.l_mark[0].str);
                    }
break;
case 26:
#line 153 "attack_parser.y"
	{
                        attack->address.kind = ADDRKIND_IPv6;
                        strcpy(attack->address.value, yystack.l_mark[0].str);
                    }
break;
case 27:
#line 157 "attack_parser.y"
	{
                        if (!attack_from_hostname(attack, yystack.l_mark[0].str)) {
                            YYABORT;
                        }
                    }
break;
#line 657 "attack_parser.c"
    }
    yystack.s_mark -= yym;
    yystate = *yystack.s_mark;
    yystack.l_mark -= yym;
    yym = yylhs[yyn];
    if (yystate == 0 && yym == 0)
    {
#if YYDEBUG
        if (yydebug)
            printf("%sdebug: after reduction, shifting from state 0 to\
 state %d\n", YYPREFIX, YYFINAL);
#endif
        yystate = YYFINAL;
        *++yystack.s_mark = YYFINAL;
        *++yystack.l_mark = yyval;
        if (yychar < 0)
        {
            if ((yychar = YYLEX) < 0) yychar = YYEOF;
#if YYDEBUG
            if (yydebug)
            {
                yys = yyname[YYTRANSLATE(yychar)];
                printf("%sdebug: state %d, reading %d (%s)\n",
                        YYPREFIX, YYFINAL, yychar, yys);
            }
#endif
        }
        if (yychar == YYEOF) goto yyaccept;
        goto yyloop;
    }
    if ((yyn = yygindex[yym]) && (yyn += yystate) >= 0 &&
            yyn <= YYTABLESIZE && yycheck[yyn] == yystate)
        yystate = yytable[yyn];
    else
        yystate = yydgoto[yym];
#if YYDEBUG
    if (yydebug)
        printf("%sdebug: after reduction, shifting from state %d \
to state %d\n", YYPREFIX, *yystack.s_mark, yystate);
#endif
    if (yystack.s_mark >= yystack.s_last && yygrowstack(&yystack) == YYENOMEM)
    {
        goto yyoverflow;
    }
    *++yystack.s_mark = (YYINT) yystate;
    *++yystack.l_mark = yyval;
    goto yyloop;

yyoverflow:
    YYERROR_CALL("yacc stack overflow");

yyabort:
    yyfreestack(&yystack);
    return (1);

yyaccept:
    yyfreestack(&yystack);
    return (0);
}
